//this program uses a flexible function to make a drawing of a simple character, 
//a little guy. we took some hard coded lines of code and rewrote them as a function
//using variables for the x and y positons (xpos, ypos), and for the head size (hs).
//we need to re-write all the relationships between the shapes if we are going to change to e
//size of the character, so we defined the x and y positions of each shape
//in terms of the head size variable. 

//when we call our drawGuy function in the draw loop, we'll need to pass in 
//values for a specific x, y and head size of the new character we want to draw.
//in our draw loop, we draw two guys, one that follows the cursor, and one that wanders from left to 
//right across the screen

int guyXpos=0; //here's a variable for the xpos of one of the guys we'll draw on screen. we can make
//him move back and forth. 
int speed=2; //speed at which our guy is moving. 
void setup()
{
  size(400,400);
  noStroke();
  smooth();
}

void draw()
{
  background(0);
  drawGuy(mouseX,mouseY, 100);//draw at cursor
  drawGuy(guyXpos,200,50); //draw another one 
  guyXpos+=speed;//add the speed to the xpos of the guy to move him 
  if(guyXpos> 400 || guyXpos<0)//is the guy off the screen?
  {
    speed = speed*-1;//if so switch directions (switch the sign on the speed)
  }  
  println(guyXpos);
  
  
}  

void drawGuy(int xpos, int ypos, int hs)
{
  
  
  fill(255);//white for the body
  //body
  rect(xpos,ypos,hs*.75,hs*.75);//190, 200,75, 75 were inital values 
  fill(200); //grey for the head
  //head
  ellipse(xpos+hs*.35,ypos,hs,hs);//luckily the ellipse for the
  //head was just 100,100 to start, so that
  //makes making the relative distances easy-- just some fractions
  //see below for original code
  fill(0);//black for the eyes
  //eyes, left and right
  ellipse(xpos+hs*.15,ypos-hs*.10,hs*.20,hs*.20);
  ellipse(xpos+hs*.55,ypos-hs*.10,hs*.20,hs*.20);
  
//this was the original code for the character.  
//we replaced all the hard coded values with variables to 
//make the code reusable...

//   fill(255);//white for the body
//  rect(190,200,75,75);
//  fill(200); //grey for the head
//  ellipse(225,200,100,100);
//  fill(0);//black for the eyes
//  ellipse(205,190,20,20);
//  ellipse(245,190,20,20);
 
  
}  
